#! /usr/bin/env python

import unittest

## nb: 'Section x.y.z' etc refers to the MRCPv2 spec


## MODES = ['Normal Mode Recognition', 
##          'Hotword Mode Recognition',
##          'Voice Enrolled Grammars',
##          'Interpretation']

## REQUEST_STATES = ["COMPLETE",
##                   "IN-PROGRESS",
##                   "PENDING"]


RECOG_STATES = ['Idle',
                'Recognizing',
                'Recognized']

class MRCP_Recogniser(object):
    """* Python implementation of MRCPv2 speech recogniser resource.

** Notes

- the event-driven, asynchronous and network elements of this class
  will be implemented using twisted_.

----------

.. _twisted: http://twistedmatrix.com

    """
    def __init__(self):
        self.state = 'Idle'
        self.speechData = None
        self.grammar = None # Section 9.5.1
        self.result = None  # Section 9.5.2
        

    def mainloop(self):
        """Event-driven resource; waits till it:
        - receives a request
        - needs to send a response
        """
        pass

    def handleRequest(self, incomingMessage):
        """
        """
        pass

    def parseMessage(self, message):
        input = MRCP2_Message(message)

    def writeMessage(self):
        output = MRCP2_Message()



class SpeechRecog(MRCP_Recogniser):
    def __init__(self):
        MRCP_Recogniser.__init__(self)

    ### Methods

    def DEFINE_GRAMMAR(self):
        pass

    def GET_RESULT(self):
        pass

    def INTERPRET(self):
        pass

    def RECOGNIZE(self):
        pass

    def START_INPUT_TIMERS(self):
        pass

    def STOP(self):
        pass

### Events

class MRCP2_RecogEvent(object):
    def __init__(self):
        pass

class START_OF_INPUT(MRCP2_RecogEvent):
    def __init__(self):
        MRCP2_RecogEvent.__init__(self)

class RECOGNITION_COMPLETE(MRCP2_RecogEvent):
    def __init__(self):
        MRCP2_RecogEvent.__init__(self)

class INTERPRETATION_COMPLETE(MRCP2_RecogEvent):
    def __init__(self):
        MRCP2_RecogEvent.__init__(self)

### Tests
        
class SpeechRecogTests(unittest.TestCase):

    def setUp(self):
        self.recog = SpeechRecog()


def main():
    unittest.main()

if __name__ == '__main__':
    main()
